#!/usr/bin/perl

$VERSION="0.1.1";
$ENV{PATH}="/usr/bin:/bin";

#
# time.cgi -- authored by paal@ekran.no, Wed Jan  5 08:49:13 CET 2000
# ---------------------------------------------------------------------

# Time Manager is a system that keeps track of how much time you have
# spent at work (or whatever). This system is ideal at workplaces which
# has a flexible time system.

# ---------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA02111-1307, USA.
# ---------------------------------------------------------------------

use Date::Manip;
use CGI qw(:cgi-lib);
use File::Copy;

# ---------------------------------------------------------------------

# the hostname, starting with http://, no trailing / 
$web_host='http://localhost';

# here's a relative path used in the forms.
$cgi_action='/cgi-bin/time/time.cgi';

# you should not alter the next line.
$cgi_url=$web_host.$cgi_action;

# comment out the language you don't want, if you comment out more than
# one language, the last language you comment out will be the default.
lang_eng(); # only english is currently supported.

# date_format. which is (day/month-year hour:minute:seconds)
# see the Date::Manip man pages if you want to change this.
$date_format="%d/%m-%Y %H:%M:%S";

$screen_bgcolor="e0e0d0";
$table_bgcolor="d5d5c5";
$text_color="000000";

# ---------------------------------------------------------------------

&ReadParse(*data);

$uact=$data{"UACT"};
$uweek=$data{"UWEEK"};

if ($uact eq "login")
{
	$unam=$data{"UNAME"};
	$upwd=$data{"UPWD"};
}


# legal cmds

$commands=" signon signoff stats delete del.exe week week.exe change change.exe change2.exe logout ";
$dat=`date`;
chomp $dat;

if ($uact eq "logout")
{
	logout()
}

# --- user authentication
if ($uact eq "login")
{
	authenticate_setcookie($unam,$upwd);
} else {
	print &PrintHeader; # html header
}

($foo,$unam,$upwd)=authenticate_parse_cookie(); # check if we have cookie
if ($foo==0) { authenticate_user(); } # writes the login screen

# initialize used variables.

($this_year)=&UnixDate($dat,"%Y"); # this_year is current year YYYY

read_datafile();  # read the datafile

if (!($uact)) # no command given, write menu screen
{
	$the_user=chk_user($unam,$upwd); # just grab user name
	head();
	menu_page();
	tail(1);
	exit 0;
}

# ---------------------------------------------------------------------------
# debug stuff information 

#foreach $line (@dblist)
#{
#	($a,$b,$c)=split /;/,$line;
#	print $line.":".&ParseDate($c).":<br>";
#}
#print "Debug: ".$ENV{'HTTP_COOKIE'}."<br>\n";
#print "Uact:".$uact." - Unam:".$unam."<br>\n";

head(); # print web header.

# ---------------------------------------------------------------------------
# check for errors

$err=0;
if (!($the_user=chk_user($unam,$upwd))) # check user authentication
{
    print $l_auth_failed."<br>\n";
	$err=$err+2; 
}

$foo=" ".$uact." ";
$_=$commands;
if (!(m/$foo/i ))
{
    print $l_action_n_spec."<br>\n";
    $err=$err+1;
}

# check previous entry -- we can't login/-out twice in a row

$line=$dblist[$entries];
($id,$action,$date)=split /;/,$line;
if (($uact eq "signoff") && ($id/2==(int($id/2)))) {
   print "<br>".$l_bad_seq."<br>\n"; $err=+4;
}
if (($uact eq "signon") && ($id/2!=(int($id/2)))) {
   print "<br>".$l_bad_seq."<br>\n"; $err=+4;
}


# ---------------------------------------------------------------------------
# no errors found lets get goin'

print "<br>\n";

if ($err==0) {
    if (($uact eq "signon") || ($uact eq "signoff")) { # store signon/out entry
       store_data($unam,$uact);
    } 
    if ($uact eq "stats") { # show statistics
       show_statistics($unam);
    }
    if ($uact eq "delete") {  # select deletion
       prep_delete($unam);
    }
    if ($uact eq "del.exe") {  # delete entries
       exec_delete($unam);
    }
    if ($uact eq "week") { # select week
       select_week();
    }
    if ($uact eq "week.exe") { # show the week
       mkweek($unam,$uweek);
    }
    if ($uact eq "change") { # select change
       prep_change($unam);
    }
    if ($uact eq "change.exe") { # select change
       exec_change($unam);
    }
    if ($uact eq "change2.exe") { # select change
       exec_change2($unam);
    }
}

tail(0);
exit 0;

# ---------------------------------------------------------------------------
# subroutines
# ---------------------------------------------------------------------------

sub read_datafile()
{
	$entries=0;
	$id="";
	$dtafile="data/".$unam.".".$this_year.".dta"; # the user database.
	open DTA,"<".$dtafile; # read and buffer datafile
	while ($i=<DTA>)
	{
		chomp $i;
		$entries++;
		push @dblist,$i; # push data onto a list that we'll later use
		($id,$tmp)=split /;/,$i;
	}
	close DTA;
	if ($id) { $next_entry=$id; } else { $next_entry=1; }
	if (substr($tmp,0,3) eq "inn") # add "nempty" if user is still online
	{
		push @dblist,($next_entry+1).";out;nempty";
	}
}

# ---------------------------------------------------------------------------
# COOKIE AUTHENTICATION

# authenticate_parse_cookie reads and parses the cookie environment variable\
# then returns username and password if it finds any.

sub authenticate_parse_cookie() 
{
	my $ck;
	my $key;
	my $value;
	my $kv;
	my $unam;
	my $upwd;
	$ck=0;

	@cookies=split (/;\s/,$ENV{'HTTP_COOKIE'}); # splits the cookies add table
	foreach $kv (@cookies)
	{
		($key,$value)=split (/=/,$kv);
		if ($key eq "user") {$unam=$value;}
		if ($key eq "pwd") {$upwd=$value;}
	}

	if (($unam) && ($upwd)) { $ck=1; }
	return ($ck,$unam,$upwd);
}

sub authenticate_user() # writes the html login screen.
{
	head();
	login_page();
	tail(1);
	exit 0;
}

sub authenticate_setcookie()
{
	my ($user,$pwd)=@_;

	print "Content-Type: text/html\n"; 
	if ($the_user=chk_user($user,$pwd))
	{
		print "Set-Cookie: user=".$user.";","\n";
		print "Set-Cookie: pwd=".$pwd.";","\n\n";
	
		head();	
		menu_page();
		tail(1);
		exit 0;
	} else {
		print "\n";
		head();
		print '<center>User failed to authenticate.<br></center>'."\n";
		tail(1);
		exit 0;
	}
}

sub logout() # log user off the system.
{
	print "Content-Type: text/html\n"; 
	print "Set-Cookie: user=;","\n";
	print "Set-Cookie: pwd=;","\n\n";
	head();
	print '<center><br><b>'.$l_logedout.'</b><br></center>'."\n";
	tail(1);
	exit 0;
}

# ---------------------------------------------------------------------------
# DISPLAY LOGIN SCREEN

sub login_page() 
{
	print '<form action="'.$cgi_action.'" method="POST">
			<table border=1 cellpadding=2 align=center bgcolor='.
				$table_bgcolor.'>
			<tr>
  				<th colspan=3>AUTHENTICATE USER</th>
			</tr>
			<tr>
  				<td>Username:</td>
  				<td align=right colspan=2>
					<input type="text" name="UNAME" size=8></td>
			</tr>
			<tr>
  				<td>Password:</td>
  				<td align=right colspan=2>
					<input type="password" name="UPWD" size=8></td>
			</tr>
			<tr>
  				<td align=right colspan=3>
  				<input type="submit" name="UACT" value="login">
  				<input type="reset" value="clear"></td>
			</tr>
			</table></form>';
}


# ---------------------------------------------------------------------------
# DISPLAY MENU SCREEN

sub menu_page()
{

print '<form action="'.$cgi_action.'" method="POST">
		<table border=1 cellpadding=2 align=center bgcolor='.$table_bgcolor.'>
		<tr>
  			<th colspan=3>WORK HOURS REGISTRATION</th>
		</tr>
		<tr>
  			<td>Sign on</td>
			<td align=right colspan=2>
				<input type="submit" name="UACT" value="signon"></td>
		</tr>
		<tr>
  			<td>Sign off</td>
  			<td align=right colspan=2>
      			<input type="submit" name="UACT" value="signoff"></td>
		</tr>
		<tr>
			<td colspan=3>&nbsp;</td>
		</tr>
		<tr>
  			<td>Week report</td>
  			<td align=right colspan=2>
      		<input type="submit" name="UACT" value="week"></td>
		</tr>
		<tr>
  			<td>General statistics</td>
  			<td align=right colspan=2>
				<input type="submit" name="UACT" value="stats"></td>
		</tr>
		<tr>
  			<td>Delete entry</td>
  			<td align=right colspan=2>
				<input type="submit" name="UACT" value="delete"></td>
		</tr>
		<tr>
  			<td>Alter entry</td>
  			<td align=right colspan=2>
				<input type="submit" name="UACT" value="change"></td>
		</tr>
		<tr>
			<td colspan=3>&nbsp;</td>
		</tr>
		<tr>
  			<td>Logout from Time Manager</td>
  			<td align=right colspan=2>
				<input type="submit" name="UACT" value="logout"></td>
		</tr>

		</table>
		</form>
	';
}

# ---------------------------------------------------------------------------
# ADD ENTRY

sub store_data()
{
	($unam,$uact)=@_;
	if ($uact eq "signon") { $action="inn"; } else { $action="out"; }

   	open DTA,">>data/".$unam.".".$this_year.".dta" ||
    	print "can't open datafile for writing...<br>\n";
	print DTA ($next_entry+1).";".$action.";".&ParseDate($dat)."\n";
	close DTA;
	print $uact." ".$l_confirm_action." ".$dat."<br>\n";
}


# ---------------------------------------------------------------------------
# CHANGE

sub prep_change()
{
	($unam)=@_;
	print '<form action="'.$cgi_action.'" method="POST">';
	print '<input type="submit" name="change.exe" value="change">';
	print '<input type="reset" value="reset">';
	print "<table border=1 cellpadding=2 bgcolor=\"".$table_bgcolor."\">\n";
	print '<tr><th colspan=3><font color="#000050">'.$l_alter_select_entry.
			'</th></tr>';
	print '<tr><td>&nbsp;</td><th>'.
				$l_from.'</th><th>'.$l_to.'</td></tr>'."\n"; 
	$inn="empty"; $out="empty"; $cnt=0; 
	foreach $line (@dblist)
	{
		($id,$act,$date)=split /;/,$line;
		if ($inn eq "empty")
			{ $inn=$date; $ice=$id } else { $out=$date; }
		if ($out ne "empty")
		{
			if ($out eq "nempty") { $out=$l_still_online; }
			print '<td>
					<input type="checkbox" name="U'.$ice.'" value="unset">
					</td>
				   <td>'.&UnixDate($inn,$date_format).'</td><td>';
			if ($out eq $l_still_online)
			{
				print $l_still_online;
			} else {
				print &UnixDate($out,$date_format);
			}
			print '</td></tr>'."\n";
			$inn="empty"; $out="empty"; $cnt++;
		} 
	}
	print '</table>'."\n";
	print '<input type="hidden" name="UACT" value="change.exe">';
	print '<input type="submit" name="change.exe" value="change">';
	print '<input type="reset" value="reset">';
}

sub exec_change()
{
	($unam)=@_;

	print '<form action="'.$cgi_action.'" method="POST">';
	print '<input type="submit" name="change2.exe" value="change2">';
	print '<input type="reset" value="reset">';

	print "<table border=1 cellpadding=2 bgcolor=\"".$table_bgcolor."\">\n";
	print '<tr><th colspan=7><font color="#000050">'.$l_alter_changeent.'</th></tr>';
	print '<tr><th>original</th>
               <th>day</th>
               <th>mon</th>
               <th>&nbsp;</th>
               <th>hrs</th>
               <th>min</th>
               <th>sec</th></tr>'."\n";

	foreach $line (@dblist)
	{
		($id,$act,$date)=split /;/,$line;
		if ((($data{"U".$id} eq "unset") || 
			($data{"U".($id-1)} eq "unset")) && ($date ne "nempty"))
		{
			print '<tr><td>'.&UnixDate($date,$date_format).'</td>';
			print '  <td><input type="text" size=2 name="dayU'.$id.'" value="'.&UnixDate($date,"%d").'"></td>';
			print '  <td><input type="text" size=2 name="monU'.$id.'" value="'.&UnixDate($date,"%m").'"></td>';
			print '  <td>&nbsp;</td>';

			print '  <td><input type="text" size=2 name="hrsU'.$id.'" value="'.&UnixDate($date,"%H").'"></td>';
			print '  <td><input type="text" size=2 name="minU'.$id.'" value="'.&UnixDate($date,"%M").'"></td>';
			print '  <td><input type="text" size=2 name="secU'.$id.'" value="'.&UnixDate($date,"%S").'"></td>';
			print '</tr>'."\n";
			if (($id/2)==(int($id/2)))
				{ print '<tr><td></td></tr>'; }
		}
	}
    print '</table>'."\n";
    print '<input type="hidden" name="UACT" value="change2.exe">';
    print '<input type="submit" name="change2.exe" value="change2">';
    print '<input type="reset" value="reset">';
    print '</form>';
}

sub exec_change2() { # perform the actual change
	($unam)=@_;

	my $idn; # id next.
	my $thise; # a regular tuppel counter
	my ($md,$mm,$mh,$mi,$ms,$ctl);
	my ($prev,$next,$thise);

	print "<b>".$l_alter_entries."</b><p>";
	print "<ul>";

	$thise=0;
	foreach $line (@dblist)
	{
		($id,$act,$date)=split /;/,$line;
		$ctl=0;
		$thise++;
		if ($data{"dayU".$id})
		{
			($prev,$next)=getnextprev($id); # get the next and previous entry
			$mm=$data{"monU".$id};
			$md=$data{"dayU".$id};
			$mh=$data{"hrsU".$id};
			$mi=$data{"minU".$id};
			$ms=$data{"secU".$id};

			$dm_new=$this_year.$mm.$md.$mh.":".$mi.":".$ms;
			$ctl=0;
			
			if ($dm_new ne $date) # check if date has been alter before ctrl.
			{

				if ($data{"dayU".($id+1)}) # next record is also altered
				{
					$idn=($id+1);
					$next=$this_year.
							$data{"monU".$idn}.
							$data{"dayU".$idn}.
							$data{"hrsU".$idn}.":".
							$data{"minU".$idn}.":".
							$data{"secU".$idn};
					if (!(&ParseDate($next)))
					{
						print $l_alter_nextillegal.".<br>";
						$ctl=+1;
					}
				}

				if (($dm_new lt $prev) && (&ParseDate($dm_new)))
				{
					print $l_alter_eprealt."<br>";
					print '<b>'.$l_alter_current.':</b> ('.
&UnixDate($date,$date_format).")<b> ".$l_alter_new.':</b> ('.
&UnixDate($dm_new,$date_format).")<b> ".$l_alter_prev.':</b> ('.
&UnixDate($prev,$date_format).")<p>";
					$ctl=1;
				}

				if (($dm_new gt $next) && (&ParseDate($dm_new)))
				{
					print $l_alter_enextalt."<br>";
					print	'<b>'.$l_alter_current.':</b> ('.
&UnixDate($date,$date_format).")<b> ".$l_alter_new.':</b> ('.
&UnixDate($dm_new,$date_format).")<b> ".$l_alter_next.':</b> ('.
&UnixDate($next,$date_format).")<p>";
					$ctl=+1;
				}

				if ($dm_new gt &ParseDate(`date`)) # can't alter to future
				{
					print $l_alter_futurealt."<br>";
					print '<b> '.$l_alter_current.'</b> ('.
&UnixDate(&ParseDate(`date`),$date_format).') <b>'.$l_alter_new.'</b> ('.
&UnixDate($dm_new,$date_format).')<br>'."\n";	
					$ctl=+1;
				}

				if (!(&ParseDate($dm_new))) # illegal date
				{
					print $l_alter_illegaldate." (".
					$md."/".$mm."-".$this_year." ".$mh.":".$mi.":".$ms.")<br>";
					$ctl=+1;
				}
			}

			print &UnixDate($date,$date_format)." -> ".
				  &UnixDate($dm_new,$date_format)." "; # write date onto scrn.

			if ($dm_new eq $date) { # nothing has been altered.
				print "--> ".$l_alter_noch.".";
				$ctl=0;
			}
		
			if ($ctl!=0) # something went wrong
			{
				print $l_alter_failed.".";
			}

			if (($ctl==0) && ($dm_new ne $date)) # success!
			{
				$foo=$id.";".$act.";".$dm_new;
				$dblist[($thise-1)]=$foo;
				print "--> ".$l_alter_ch.".";
			}
			print "<br><p>\n";
    	}
	}
	alter_file();
	print "</ul>";
}

sub alter_file()
{
	open DTA,">".$dtafile; # write new table to datafile.
	foreach $lineb (@dblist)
 	{
		($foo,$foo,$datex)=split /;/,$lineb;
		if ($datex ne "nempty")
		{
			print DTA $lineb."\n"; # a new line
		}
	}
	close DTA;
}

sub getnextprev() # returns next and previous entry in the table
{
	my ($ida)=@_;

	my ($idb,$chk,$linex,$timex,$prev,$next);

	$chk=0;
	foreach $linex (@dblist)
	{
		($idb,$foo,$timex)=split /;/,$linex;
		if ($chk==1) { $next=$timex; $chk=2;} # grab next in next turn
		if (($ida eq $idb) && ($chk==0)) { $chk=1; }
		if ($chk==0) { $prev=$timex; } # grab previous while not found
	}
	return ($prev,$next);
}

# ---------------------------------------------------------------------------
# DELETE
 
# prepare to delete entry 
sub prep_delete()
{
	($unam)=@_;
	print '<form action="'.$cgi_action.'" method="POST">';
	print "<table border=1 cellpadding=2 bgcolor=\"".$table_bgcolor."\">\n";
	print '<tr><th colspan=3><font color="#000050">'.
				$l_select_del_title.'</th></tr>
			<tr><td>&nbsp;</td><th>'.$l_from.'</th><th>'.
				$l_to.'</td></tr>'."\n"; 
	print '<input type="submit" name="del.exe" value="delete">
			<input type="reset" value="reset">';
	$inn="empty"; $out="empty"; $cnt=0; 
	foreach $line (@dblist)
	{
		($id,$act,$date)=split /;/,$line;
		if ($inn eq "empty")
			{ $inn=$date; } else { $out=$date; }
		if ($out ne "empty") {
			if ($out eq "nempty") { $out=$l_still_online; }
			print '<td><input type="checkbox" name="U'.
					   ($id-1).'" value="unset"></td>
				   <td>'.&UnixDate($inn,$date_format).'</td><td>';
			if ($out eq $l_still_online)
			{
				print $l_still_online;
			} else {
				print &UnixDate($out,$date_format);
			}
		    print '</td></tr>'."\n";
			$inn="empty"; $out="empty"; $cnt++;
		} 
	}
	print '</table>'."\n";
	print '<input type="hidden" name="UACT" value="del.exe">';
	print '<input type="submit" name="del.exe" value="delete">';
	print '<input type="reset" value="reset">';
}

# execute the deletion
sub exec_delete() {

  foreach $line (@dblist) { # pick the ones not set for deletion
     ($id,$act,$date)=split /;/,$line;
     if (($data{"U".$id} eq "unset") || 
         ($data{"U".($id-1)} eq "unset")) {
       push @deleted,$line; # for information purposes only
     } else {
       push @newlst,$line;  # these we wanna keep
     }
     $prev=$line;
  }
  $bakfile="time/".$unam.".".$this_year.".bak";
  copy ($dtafile,$bakfile); # Make a backup file
  open DTA,">".$dtafile; # write new datafile
  foreach $line (@newlst) {
    if ($line ne ($next_entry+1).";out;nempty") { # exclude tail record
       print DTA $line."\n"; 
     }     
  }
  close DTA;
  print "<b>".$l_deleted_lines."</b> <p>\n";
  $cnt=0; $lcnt=0;
  foreach $line (@deleted) {
       ($foo,$foo,$line)=split /;/,$line;
       if (($cnt/2) != (int($cnt/2))) {
            print &UnixDate($prev,$date_format)." to ".
					&UnixDate($line,$date_format)."<br>\n";
            $lcnt=1;
       }
       $cnt++;
       $prev=$line;
  }
  if ($lcnt==0) {
     print "<dd>".$l_nodeleted_lines."<br>";
  }
}


# ---------------------------------------------------------------------------
# WEEKLY REPORTS 

sub select_week() {
	print "<ul>";
	foreach $line (@dblist)
	{
		($id,$action,$date)=split /;/,$line;
		$wk=&UnixDate($date,"%W");
		if (($action eq "inn") && (0==chk_weeklst($wk))) {
        	push @av_week,$wk;
     	}
  	} 

  	print '<form action="'.$cgi_action.'" method="POST">';
	print '<table border=1 bgcolor="'.$table_bgcolor.'">
			<tr><th colspan=4>'.$l_select_week_display.'</th></tr>
  			<tr><td>&nbsp;</td><th>'.$l_week_no.'</th><th>'.$l_start.'</th>
			<th>'.$l_end.'</th></tr>';

	foreach $line (@av_week)
	{
		$from=&UnixDate(&ParseDate("monday week ".$line." of ".
						$this_year),"%d/%m");
 		$to=&UnixDate(&ParseDate("sunday week ".$line." of ".
						$this_year),"%d/%m");

		print '<tr><td>
				<input type="radio" name="UWEEK" value="'.$line.'"></td>
				<td align=center>'.$line.'</td>
				<td>'.$from.'</td><td>'.$to."</td></tr>"; 
  	}

	print '<tr><td colspan=4 align=right>';
	print '<input type="hidden" name="UACT" value="week.exe">';
	print '<input type="submit" name="week.exe" value="show">';
	print '<input type="reset" value="reset">';
	print '</table>';
	print "<\/ul><br>";
 
}

# -----------------------------------------------------------------------
# check if a list has already been pushed onto the "available week list".
sub chk_weeklst()
{
	my ($wno)=@_;
	foreach $l (@av_week)
	{
		if ($l eq $wno) { return 1; } 
	}
	return 0;
}


# -------------------
# print weekly report
sub mkweek() {
	($unam,$uweek)=@_;

	my @dows=(0,0,0,0,0,0,0,0,0,0,0,0,0,0);
	my @dowm=(0,0,0,0,0,0,0,0,0,0,0,0,0,0);
	my @dowt=(0,0,0,0,0,0,0,0,0,0,0,0,0,0); # hours/mins/secs each day
	my @the_week=("monday","tuesday","wednesday","thursday",
                 "friday","saturday","sunday");
	my $day_cnt=0;
	my $dx=0; # date at this day this week
	my $dy=0; # date in logfile

	my $date1="empty";
	my $date2="empty";
	my $utim=0; my $umin=0; my $usec=0;
   
	my @wload=("&nbsp;<br>","&nbsp;<br>","&nbsp;<br>","&nbsp;<br>",
				"&nbsp;<br>","&nbsp;<br>","&nbsp;<br>");

	foreach $this_day (@the_week) # this_day is day being processed.
	{
		$dx=substr(&ParseDate($this_day." week ".$uweek." ".$this_year),0,8);
		foreach $line (@dblist)
		{
			($id,$action,$date)=split /;/,$line;
			if ($date1 eq "empty")
				{ $date1=$date; } else { $date2=$date; }
			if ($date2 ne "empty") # turn around and read date2
			{
				if ($date2 eq "nempty") # use current if still online
				{
					$date2=&ParseDate($dat);
					$stillon=1;
            	} else {
					$stillon=0;
				}

            	$delta=&DateCalc($date2,$date1,\$erro); # time spent
            	($foo,$foo,$uw,$ud,$ut,$um,$us)=split /:/,$delta;
            	while ($uw!=0) { $uw--; $ud=$ud+7; }  # long workhours
            	while ($ud!=0) { $ud--; $ut=$ut+24; } # very long workhours

				$dy=substr($date1,0,8); #  this date
				if ($dx eq $dy) # the current entry is at this specific day!
				{
 
					($dowt[$day_cnt],$dowm[$day_cnt],$dows[$day_cnt])=
						addtms($dowt[$day_cnt],$dowm[$day_cnt],
								$dows[$day_cnt],$ut,$um,$us);
					($utim,$umin,$usec)=
            			addtms($utim,$umin,$usec,$ut,$um,$us);

					$wload[$day_cnt]=$wload[$day_cnt].
						&UnixDate($date1,$date_format)."<br>";
					if ($stillon==0)
					{
						$wload[$day_cnt]=$wload[$day_cnt].
						&UnixDate($date2,$date_format)."<br><br>\n";
 					} else {
						$wload[$day_cnt]=$wload[$day_cnt].
						$l_still_online."<br><br>\n";
					}
 
          		}
            	$date1="empty"; $date2="empty";
			}
		}
		$day_cnt++;
	}

  # dow[tms] now contains time spent each of the day for this specific week.

	print "<br>\n"; 
	print "<table border=1 cellpadding=2 bgcolor=\"".$table_bgcolor."\">";
	print '<tr><th colspan=5><font color="000050">'.$l_work_stat_week." ".
			($uweek).' for '.$the_user.'</th></tr>';

	print '<tr><th>dag</th><th>from/to</th><th>hours</th>
			<th>minutes</th><th>seconds</th></tr>';

	$day_cnt=0; 
	foreach $this_day (@the_week)
	{
		print '<tr><td align=left>'.$week_name[$day_cnt].'</td>
                <td align=left><font size="-1">'.$wload[$day_cnt].'</font></td>
                <td align=right>'.$dowt[$day_cnt].'</td>
                <td align=right>'.$dowm[$day_cnt].'</td>
                <td align=right>'.$dows[$day_cnt].'</td></tr>';
		print "\n";
		$day_cnt++;
	}
	print '<tr><td align=left>'.$l_total.'</td>
 			 <td align=center>&nbsp;</td>
             <td align=right>'.$utim.'</td>
             <td align=right>'.$umin.'</td>
             <td align=right>'.$usec.'</td></tr>';
	print "\n"; print '</table>';
	print "<br>\n";
}

# -----------------------
# display user statistics

sub show_statistics() {
   ($unam)=@_;

   my $uday=0; my $utim=0; my $umin=0; my $usec=0;
   my @wkt=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
   my @wkm=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
   my @wks=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
   @mkt=(0,0,0,0,0,0,0,0,0,0,0,0,0,0); @mkm=(0,0,0,0,0,0,0,0,0,0,0,0,0,0);
   @mks=(0,0,0,0,0,0,0,0,0,0,0,0,0,0); # Month[hour.minute.sec] count
   @dows=(0,0,0,0,0,0,0,0,0,0,0,0,0,0); @dowm=(0,0,0,0,0,0,0,0,0,0,0,0,0,0);
   @dowt=(0,0,0,0,0,0,0,0,0,0,0,0,0,0); # Day of week [hour.minute.sec.] count

# ----------------------------------
# read and analyze data from time db

   $date1="empty"; $date2="empty";
   foreach $line (@dblist) {
       ($id,$action,$date)=split /;/,$line;
       if ($date1 eq "empty") {$date1=$date;} else {$date2=$date;}
       if ($date2 ne "empty") {
          if ($date2 eq "nempty") { # use current datestamp if still online
             $date2=$dat; $stillon=1;
          } else {$stillon=0;}

          $delta=&DateCalc($date2,$date1,\$erro); # time spent
          ($foo,$foo,$uw,$ud,$ut,$um,$us)=split /:/,$delta;
          while ($uw!=0) { $uw--; $ud=$ud+7; }
          while ($ud!=0) { $ud--; $ut=$ut+24; }

          ($y)=&UnixDate($date1,"%Y"); # find which week we are in.
          ($m)=&UnixDate($date1,"%m");
          ($d)=&UnixDate($date1,"%d");
          $wkno=&Date_WeekOfYear($m,$d,$y,1); # now we know what week we have
          $dow=&Date_DayOfWeek($m,$d,$y);     # check which day of week it is

       # add statistics to the misc. tables
          ($wkt[$wkno],$wkm[$wkno],$wks[$wkno])=
                addtms($wkt[$wkno],$wkm[$wkno],$wks[$wkno],$ut,$um,$us);

          ($mkt[$m],$mkm[$m],$mks[$m])=
                addtms($mkt[$m],$mkm[$m],$mks[$m],$ut,$um,$us);
          ($dowt[$dow],$dowm[$dow],$dows[$dow])=
                addtms($dowt[$dow],$dowm[$dow],$dows[$dow],$ut,$um,$us);
          ($utim,$umin,$usec)=addtms($utim,$umin,$usec,$ut,$um,$us);
          while ($utim>=24) {
             $uday++; $utim=$utim-24;
          }
          if ($stillon==1) { # user is still online, print dummy at logof field
              push @list,"<tr><td align=right>".&UnixDate($date1,"%d/%m-%Y %H:%M:%S")."<\/td><td align=right>".$l_still_online."</td><td align=right>".$ut."<\/td><td align=right>".$um."<\/td><td align=right>".$us."<\/td>\n";
          } else {
              push @list,"<tr><td align=right>".&UnixDate($date1,"%d/%m-%Y %H:%M:%S")."<\/td><td align=right>".&UnixDate($date2,"%d/%m-%Y %H:%M:%S")."</td><td align=right>".$ut."<\/td><td align=right>".$um."<\/td><td align=right>".$us."<\/td>\n";
          }
          $date1="empty"; $date2="empty";
       }
   }

# ---------------------------
# sum each weeks' total hours

   for ($cnt=1; $cnt<54; $cnt++) {
      # summarize work each week
      if (($wks[$cnt]!=0) || ($wkm[$cnt]!=0) || ($wkt[$cnt]!=0)) {
        push @week,"<tr><td align=right>".$cnt."<\/td><td align=right>".$wkt[$cnt]."<\/td><td align=right>".$wkm[$cnt]."<\/td><td align=right>".$wks[$cnt]."<\/td><\/tr>\n";
      } 
      # summarize work each month
      if (($cnt<13)&&(($mks[$cnt]!=0) || ($mkm[$cnt]!=0) || ($mkt[$cnt]!=0))) {
           push @month,"<tr><td align=right>".$year_name[$cnt-1]."<\/td><td align=right>".$mkt[$cnt]."<\/td><td align=right>".$mkm[$cnt]."<\/td><td align=right>".$mks[$cnt]."<\/td><\/tr>\n";
      }
      # summarize work each weekday
      if (($cnt<8) && (($dows[$cnt]!=0)||($dows[$cnt]!=0)||($dows[$cnt]!=0))) {
           push @dowli,"<tr><td align=right>".$week_name[($cnt-1)]."<\/td><td align=right>".$dowt[$cnt]."<\/td><td align=right>".$dowm[$cnt]."<\/td><td align=right>".$dows[$cnt]."<\/td><\/tr>\n";
      }
   }



# ------------------------------------------------------------
# all processing is done, lets get something out on the screen 

   print '<p align=center>
              <center><h2>'.$l_work_stats_for.' '.$the_user.'</h2>
              </center></p>
          '."\n";

  # statistics for this year
  print "\n<br><table border=1 cellpadding=2 bgcolor=\"".$table_bgcolor."\">";
  print '<tr><th colspan=4><font color="#000050">
           '.$l_work_this_year.'
             </th>
        </tr>
        <tr><th>'.$l_days.'</th>
            <th>'.$l_hours.'</th>
            <th>'.$l_mins.'</th>
            <th>'.$l_secs.'</th>
        </tr>';
  print '<tr><td align=right>'.$uday.'</td>
             <td align=right>'.$utim.'</td>
             <td align=right>'.$umin.'</td>
             <td align=right>'.$usec.'</td>
         </tr>
         </table><br></b>';

  # monthly statistics
  tblhead4c($l_work_by_month,$l_month,$l_hours,$l_mins,$l_secs,@month);

  # weekly statistics
  tblhead4c($l_work_by_week,$l_week_no,$l_hours,$l_mins,$l_secs,@week);

  # day of week statistics
  tblhead4c($l_work_by_weekdays,$l_day,$l_hours,$l_mins,$l_secs,@dowli);

  # statistics by session
  tblhead5c($l_work_by_sessions,$l_from,$l_to,$l_hours,$l_mins,$l_secs,@list);

}


# ---------------------------------------------------------------------------
# tools

sub tblhead5c() { # write a generic table with 5 columns
  my ($txt,$a1,$a2,$a3,$a4,$a5,@list)=@_;
  print "<br><table border=1 cellpadding=2 bgcolor=\"".$table_bgcolor."\">";
  print "<tr><th colspan=5><font color=\"#000050\">".$txt."<\/font><\/th><\/tr>\n";
  print "<tr><th>".$a1."<\/th><th>".$a2."<\/th><th>".$a3."<\/th><th>".$a4."<\/th><th>".$a5."<\/th></tr>\n";
  foreach $line (@list) {
    print $line;
  }   
  print "<\/table>\n";
}

sub tblhead4c() { # write a generic table with 4 columns
  my ($txt,$a1,$a2,$a3,$a4,@list)=@_;
  print "<br><table border=1 cellpadding=2 bgcolor=\"".$table_bgcolor."\">";
  print "<tr><th colspan=5><font color=\"#000050\">".$txt."<\/font><\/th><\/tr>\n";
  print "<tr><th>".$a1."<\/th><th>".$a2."<\/th><th>".$a3."<\/th><th>".$a4."<\/th></tr>\n";
  foreach $line (@list) {
    print $line;
  }   
  print "<\/table>\n";
}

# take two sets of HHMMSS and adds them together (6 parameters in, 3 out).
sub addtms()
{
	my ($t,$m,$s,$t2,$m2,$s2)=@_;

	$s=$s+$s2;
	if ($s>=60) { $s=$s-60; $m++; }
	$m=$m+$m2;
	if ($m>=60) { $m=$m-60; $t++; }
	$t=$t+$t2;
	return ($t,$m,$s);
}

# -------------------------------------------------------------
# check username and password (we'll need to add crypting here)
sub chk_user()
{
	($unam,$upwd)=@_;
	my ($una,$upw);
	my $the_user="";

	open PWD,"<time.pwd";
	while (<PWD>)
	{
		chomp;
		($una,$gcos_name,$upw)=split /:/;
		if (($una eq $unam) && ($upw eq $upwd))
		{
			$the_user=$gcos_name;
		}
	}
	return ($the_user);
}

# the top of the html document.
sub head()
{
	print '<html><head><title>Time Manager</title></head>';
	print "\n<body bgcolor=\"".$screen_bgcolor."\" text=\"".$text_color."\">\n";
	print "<br><hr noshade>\n";
}

sub tail()
{
	($menuflag)=@_;

	print '<br><hr noshade>
         <table width="100%">
           <tr><td align=left>';
	if ($menuflag==0)
	{
		print '<font size="1">[ <a href="'.$cgi_url.'">menu</a> ]';
		print '<font size="1">[ <a href="'.$cgi_url.'?UACT=logout">logout</a> ]';
		print '</font>';
	}
	print '</td>
	<td align=right><font size="1"><b>';
    if ($the_user) { print $the_user.', '; }
	print $dat.'<br></font></td></tr></table></body></html>';
	print "\n";
}

# ------------------------------------------------
# a brief implementation of the norwegian language

# norwegian (and maybe other languages will be supported later.

sub lang_eng()
{
	$l_action_n_spec="You forgot to specify action (signon/signoff/etc..)";
	$l_auth_failed="Username and/or password was not written correctly!";
	$l_bad_seq="You are trying to signon or signoff two times in a row!";
	$l_confirm_action="registered";
	$l_work_stats_for="Work-time statistics for";
	$l_still_online="-- still at work --";
	$l_select_del_title="Select which entry you want to delete";
	$l_select_week_display="Select week to display:<p>";
	$l_deleted_lines="The following entries was deleted:";
	$l_nodeleted_lines="No lines were deleted.";

	$l_alter_entries="Altering entries.";
	$l_alter_eprealt="can not alter the time/date to a time/date earlier than
						the previous log entry (time/date will overlap.)";
	$l_alter_enextalt="can not alter the time/date to a time/date later than
						the next log entry (time/date will overlap.)";
	$l_alter_futurealt="the time/date you tried to alter to is in the future.";
	$l_alter_illegaldate="the time/date you entered is illegal";
	$l_alter_current="current";
	$l_alter_new="new";
	$l_alter_next="next";
	$l_alter_prev="previous";
	$l_alter_failed="failed";
	$l_alter_noch="no change";
	$l_alter_ch="changed";
	$l_alter_changeent="Alter Entry";
	$l_alter_select_entry="Select Entry to Alter";
	$l_alter_nextillegal="Change failed because next entry is illegal";

	$l_logedout='You have loged out from the system.<br>Have a nice day.';
  	$l_work_by_sessions="Workhours by sessions";
  	$l_work_by_weekdays="Workhours by weekdays";
  	$l_work_by_week="Workhours by week";
  	$l_work_by_month="Workhours by month";
  	$l_work_this_year="Workhours this whole perion (year)";
  	$l_work_stat_week="Workhours for week no.";

	$l_month="month";
  	$l_week_no="week no.";
  	$l_day="day";
  	$l_days="days";
  	$l_from="from";
  	$l_to="to";
  	$l_hours="hours";
  	$l_mins="minutes";
  	$l_secs="seconds";
  	$l_total="total";
  	$l_week_no="Week No.";
  	$l_start="Start";
  	$l_end="End";

  	@year_name=("january","february","march","april","may","june","july","august","september","october","november","december");
	@week_name=("monday","tuesday","wednesday","thursday","friday","saturday","sunday");

}


